#!/usr/bin/env python
# -*- coding: utf-8 -*-
# __author__ = 'giorgos'
from paillier.paillier import *

# Δημιουργία ζεύγους ιδιωτικού και δημόσιου κλειδιού priv και pub
# To 512 είναι το μέγεθος του N σε bit
# Αφού υπολογίσετε το Tmax τότε μπορείτε να το μετατρέψετε σε αριθμό bits με την συνάρτηση tmax.bit_length()

priv, pub = generate_keypair(64)
print("\nΤο ζεύγος των κλειδιών είναι :\n%s\n%s\n" % (priv,pub))

# Κρυπτογράφηση με το δημόσιο κλειδί pub του αριθμού 1346

plain = 1346
c = encrypt(pub, plain)
print("Το %d κρυπτογραφήθηκε σε %d\n"%(plain,c))

# Aποκρυπτογράφηση με το ιδιωτικό κλειδί priv του αριθμού c

dec_value = decrypt(priv,pub,c)

print("Το %d αποκρυπτογραφήθηκε σε %d\n"%(c,dec_value))

# Πρόσθεση στο κρυπτογραφημένων ποσοτήτων
# Τα p1 και p2 κρυπτογραφούνται και η πρόσθεσή τους γίνεται στο επίπεδο των κρυπρτοκειμένων
# Όταν το αποτέλεσμα αποκρυπτογραφηθεί δίνει το άθροισμά τους στον χώρο των απλών κειμένων

p1 = 30
c1 = encrypt(pub, p1)
print("To p1 = %d κρυπτογραφήθηκε σε c1 = %d" % (p1,c1))
p2 = 27
c2 = encrypt(pub, p2)
print("Το p2 = %d κρυπτογραφήθηκε σε c2 = %d" % (p2,c2))

z = e_add(pub, c1, c2)
p = decrypt(priv, pub, z)
print("Το c1+c2 = %d αποκρυπτογραφήθηκε σε %d που ισούται με το p1+p2\n" % (z,p))

# Αντίστοιχα υπάρχουν οι συναρτήσεις για τις άλλες δύο ιδιότητες του Paillier

a = e_add_const(pub,c1,15)
p1_add = decrypt(priv,pub,a)

print("Μπορώ σε επίπεδο κρυπτοκειμένων να προσθέσω στο p1 το 15 οπότε παίρνω %d -> %d\n" % (a,p1_add))

b = e_mul_const(pub,c1,3)
p1_mul = decrypt(priv,pub,b)

print("Μπορώ σε επίπεδο κρυπτοκειμένων να πoλλαπλασιάσω στο p1 με το 3 οπότε παίρνω %d -> %d\n" % (a,p1_mul))

# Για την μετατροπή ενός αριθμού από το 10δικό σύστημα σε κάποιο άλλο με βάση b ο κώδικας είναι ο εξής

k = 67
b = 4
a = 0 # Δεν είναι απαραίτητο, απλά το χρησιμοποιούμε γισ την εκτύπωση
while k != 0:
    digit = k % b # Το digit είναι το στοιχείο που θέλετε να κρατήσετε
    print("%d * %d^%d" % (digit,b,a))
    a = a + 1
    k = k / b

